function[xArc,yArc] = CalculateArc(iCircle,iLastDirection,p1,q1,p2,q2)
%function [x, y] = CalculateArc(iLastCircle,p1,q1,p2,q2)  
global ppdCircleData L R ppdPath;
p0 = ppdCircleData(iCircle, 1);
q0 = ppdCircleData(iCircle, 2);
r1 = ppdCircleData(iCircle, 4);
i = ppdPath (3, iCircle);

p = 1 / (2*pi); %pas
P0= [p0 q0];    %Center circle position
P1= [p1 q1];    %Start tangent position
P2= [p2 q2];    %End tangent position
v1 = P1-P0;
v2 = P2-P0;
v3 = [0 -1;1 0]*v1';


    if  iLastDirection == L 
       
        %clockwise
        
        a = linspace(0,mod(atan2(det([v1',v2']),dot(v1,v2)),(-2*pi)-(i*(2*pi)))); 
        OffsetCorrection = atan2(q1 - q0, p1 - p0)
        sa = r1*sin(a+OffsetCorrection);
        ca = r1*cos(a+OffsetCorrection); 
        plot3((ca+p0),(sa+q0),-(a*p),'m*'); %Helix going UP with the '-' on the Z value 

    else
        
        %counter clockwise
        a = linspace(0,mod(atan2(det([v1',v2']),dot(v1,v2)),(2*pi)+(i*(2*pi))));
        OffsetCorrection = atan2(q1 - q0, p1 - p0)
        sa = r1*sin(a+OffsetCorrection);
        ca = r1*cos(a+OffsetCorrection);         

        plot3((ca+p0),(sa+q0),(a*p),'m*');  

    end
     
v = v1'*cos(a)+((norm(v1)/norm(v3))*v3)*sin(a);
plot(v(1,:)+p0,v(2,:)+q0,'c*') % Plot arc, centered at P0



axis equal;
grid on ;

xArc = v(1,:)'+p0;
yArc = v(2,:)'+q0;

end