function [x1,y1,x2,y2] = CalculateTangentPoint(iCircle1, iCircle2, bStartLeft, bEndLeft) 
global ppdCircleData;

p1 = ppdCircleData(iCircle1, 1);
q1 = ppdCircleData(iCircle1, 2);
u1 = ppdCircleData(iCircle2, 3)
r1 = ppdCircleData(iCircle1, 4);

p2 = ppdCircleData(iCircle2, 1);
q2 = ppdCircleData(iCircle2, 2);
u1 = ppdCircleData(iCircle2, 3);
r2 = ppdCircleData(iCircle2, 4);
l=5;							%Length
z1= 0
z2= 0
n = 50;  % 50 point approximation
angle = 0:2*pi/n:2*pi; % vector of angles at which points are drawn
P1 = p1+r1*cos(angle);  Q1 = q1+r1*sin(angle); % Coordinates of circle
P2 = p2+r2*cos(angle);  Q2 = q2+r2*sin(angle); % Coordinates of circle

%________________________________________________________________________________________
%TANGEANTES EXTERIEURS
%Tangeante gauche
d2 = (p2-p1)^2+(q2-q1)^2;
R1 = sqrt(d2-(r2-r1)^2);
s1 = ((q2-q1)*R1+(p2-p1)*(r2-r1))/d2;
c1 = ((p2-p1)*R1-(q2-q1)*(r2-r1))/d2;
xl1 = p1-r1*s1;
yl1 = q1+r1*c1;
xl2 = p2-r2*s1;
yl2 = q2+r2*c1;

%Tangeante droite
R2 = sqrt(d2-(r1-r2)^2);
s2 = ((q2-q1)*R2+(p2-p1)*(r1-r2))/d2;
c2 = ((p2-p1)*R2-(q2-q1)*(r1-r2))/d2;
xr1 = p1+r1*s2;
yr1 = q1-r1*c2;
xr2 = p2+r2*s2;
yr2 = q2-r2*c2;

%Tangeante gauche
XL = [xl1 xl2];
YL = [yl1 yl2];
%Tangeante droite
XR = [xr1 xr2];
YR = [yr1 yr2];

%________________________________________________________________________________________
%TANGEANTES INTERIEURES
xp = (p2*r1+p1*r2)/(r1+r2);
yp = (q2*r1+q1*r2)/(r1+r2);
%calculate the coordinates on the first circle
xt1 = ((r1^2*(xp-p1)+r1*(yp-q1)*sqrt((xp-p1)^2+(yp-q1)^2-r1^2))/((xp-p1)^2+(yp-q1)^2))+p1;
xt2 = ((r1^2*(xp-p1)-r1*(yp-q1)*sqrt((xp-p1)^2+(yp-q1)^2-r1^2))/((xp-p1)^2+(yp-q1)^2))+p1;
yt1 = ((r1^2*(yp-q1)+r1*(xp-p1)*sqrt((xp-p1)^2+(yp-q1)^2-r1^2))/((xp-p1)^2+(yp-q1)^2))+q1;
yt2 = ((r1^2*(yp-q1)-r1*(xp-p1)*sqrt((xp-p1)^2+(yp-q1)^2-r1^2))/((xp-p1)^2+(yp-q1)^2))+q1;
%calculate the coordinates on the second circle
xt3 = ((r2^2*(xp-p2)+r2*(yp-q2)*sqrt((xp-p2)^2+(yp-q2)^2-r2^2))/((xp-p2)^2+(yp-q2)^2))+p2;
xt4 = ((r2^2*(xp-p2)-r2*(yp-q2)*sqrt((xp-p2)^2+(yp-q2)^2-r2^2))/((xp-p2)^2+(yp-q2)^2))+p2;
yt4 = ((r2^2*(yp-q2)-r2*(xp-p2)*sqrt((xp-p2)^2+(yp-q2)^2-r2^2))/((xp-p2)^2+(yp-q2)^2))+q2;
yt3 = ((r2^2*(yp-q2)+r2*(xp-p2)*sqrt((xp-p2)^2+(yp-q2)^2-r2^2))/((xp-p2)^2+(yp-q2)^2))+q2;

%tangeante commencant a droite finissant a gauche
XIR = [xt1 xt3];
YIR = [yt1 yt3];
%tangeante commencant a gauche finissant a droite
XIL = [xt2 xt4];
YIL = [yt2 yt4];

%________________________________________________________________________________________

SO=((q1-yt1)*(yp-yt1))/((xt1-p1)*(xt1-xp)) %/!\ Correct if SI & SO=1
SI=((q2-yt3)*(yp-yt3))/((xt3-p2)*(xt3-xp)) %/!\ Correct if SI & SO=1

if bStartLeft
    
    if bEndLeft %LL
        x1 = XL(1)
        y1 = YL(1)
    	x2 = XL(2)
    	y2 = YL(2)       
    else        %LR
        x1 = XIL(1)
    	x2 = XIL(2)
        y1 = YIR(1)
    	y2 = YIR(2)
    end
else
    if bEndLeft %RL
        x1 = XIR(1)
        y1 = YIL(1)
    	x2 = XIR(2)
    	y2 = YIL(2)
    else        %RR
        x1 = XR(1)
        y1 = YR(1)
    	x2 = XR(2)
        y2 = YR(2)
    end

end



%DRAWING
hold on %drawing multiple things
%SCALE & AXIS
%TANGEANTES
X1 = [x1,y1,z1];
X2 = [x2,y2,z2];

% Their vertial concatenation is what you want
pts = [X1; X2];

% Alternatively, you could use plot3:
plot3(pts(:,1), pts(:,2), pts(:,3),'color','r')
% % coordonnes
cyl1 = [p1 q1 -5 p1 q1 l r1];
cyl2 = [p2 q2 -5 p2 q2 l r2];
 
[a b] = cylinderMesh(cyl1);
[c d] = cylinderMesh(cyl2);

% drawMesh(a, b, 'FaceColor', 'g');
% hold on
% drawMesh(c, d, 'FaceColor', 'b');
% view(60,60)


% CIRCLE
plot(P1,Q1,'g');  % Plot circle 1
plot(P2,Q2,'g');  % Plot circle 2

 


end